/* AT91SAM9XEGDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"


/* p[}l[WgRg[(PMC) */
#define PMC_SCER		((volatile unsigned int *)(0xFFFFFC00+0x00))
#define PMC_SCDR		((volatile unsigned int *)(0xFFFFFC00+0x04))
#define PMC_SCSR		((volatile unsigned int *)(0xFFFFFC00+0x08))

#define PMC_PCER		((volatile unsigned int *)(0xFFFFFC00+0x10))
#define PMC_PCDR		((volatile unsigned int *)(0xFFFFFC00+0x14))
#define PMC_PCSR		((volatile unsigned int *)(0xFFFFFC00+0x18))

#define CKGR_MOR		((volatile unsigned int *)(0xFFFFFC00+0x20))
#define CKGR_MCFR		((volatile unsigned int *)(0xFFFFFC00+0x24))
#define CKGR_PLLAR		((volatile unsigned int *)(0xFFFFFC00+0x28))
#define CKGR_PLLBR		((volatile unsigned int *)(0xFFFFFC00+0x2C))
#define PMC_MCKR		((volatile unsigned int *)(0xFFFFFC00+0x30))

#define PMC_PCK0		((volatile unsigned int *)(0xFFFFFC00+0x40))
#define PMC_PCK1		((volatile unsigned int *)(0xFFFFFC00+0x44))

#define PMC_SR			((volatile unsigned int *)(0xFFFFFC00+0x68))

#define MASTER_CLOCK	(198656000/2)

/* ėpI/Oo̓Rg[(PIOB) */
#define PIOB_PER		((volatile unsigned int *)(0xFFFFF600+0x00))
#define PIOB_PDR		((volatile unsigned int *)(0xFFFFF600+0x04))
#define PIOB_OER		((volatile unsigned int *)(0xFFFFF600+0x10))
#define PIOB_ODR		((volatile unsigned int *)(0xFFFFF600+0x14))
#define PIOB_IFER		((volatile unsigned int *)(0xFFFFF600+0x20))
#define PIOB_IFDR		((volatile unsigned int *)(0xFFFFF600+0x24))
#define PIOB_IFSR		((volatile unsigned int *)(0xFFFFF600+0x28))
#define PIOB_SODR		((volatile unsigned int *)(0xFFFFF600+0x30))
#define PIOB_ODSR		((volatile unsigned int *)(0xFFFFF600+0x38))
#define PIOB_PDSR		((volatile unsigned int *)(0xFFFFF600+0x3C))
#define PIOB_IER		((volatile unsigned int *)(0xFFFFF600+0x40))
#define PIOB_IDR		((volatile unsigned int *)(0xFFFFF600+0x44))
#define PIOB_IMR		((volatile unsigned int *)(0xFFFFF600+0x48))
#define PIOB_ISR		((volatile unsigned int *)(0xFFFFF600+0x4C))
#define PIOB_ASR		((volatile unsigned int *)(0xFFFFF600+0x70))
#define PIOB_BSR		((volatile unsigned int *)(0xFFFFF600+0x74))
#define PIOB_OWER		((volatile unsigned int *)(0xFFFFF600+0xA0))
#define PIOB_OWDR		((volatile unsigned int *)(0xFFFFF600+0xA4))

/* ėpI/Oo̓Rg[(PIOC) */
#define PIOC_PER		((volatile unsigned int *)(0xFFFFF800+0x00))
#define PIOC_PDR		((volatile unsigned int *)(0xFFFFF800+0x04))
#define PIOC_OER		((volatile unsigned int *)(0xFFFFF800+0x10))
#define PIOC_ODR		((volatile unsigned int *)(0xFFFFF800+0x14))
#define PIOC_ODSR		((volatile unsigned int *)(0xFFFFF800+0x38))
#define PIOC_PDSR		((volatile unsigned int *)(0xFFFFF800+0x3C))
#define PIOC_ASR		((volatile unsigned int *)(0xFFFFF800+0x70))
#define PIOC_BSR		((volatile unsigned int *)(0xFFFFF800+0x74))

/* OoXRg[(Static Memory Contlloer) */
#define SMC0_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x00))
#define SMC0_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x04))
#define SMC0_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x08))
#define SMC0_MODE		((volatile unsigned int *)(0xFFFFEC00+0x0C))

#define SMC2_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x20))
#define SMC2_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x24))
#define SMC2_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x28))
#define SMC2_MODE		((volatile unsigned int *)(0xFFFFEC00+0x2C))

#define SMC4_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x40))
#define SMC4_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x44))
#define SMC4_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x48))
#define SMC4_MODE		((volatile unsigned int *)(0xFFFFEC00+0x4C))

#define SMC5_SETUP		((volatile unsigned int *)(0xFFFFEC00+0x50))
#define SMC5_PLUSE		((volatile unsigned int *)(0xFFFFEC00+0x54))
#define SMC5_CYCLE		((volatile unsigned int *)(0xFFFFEC00+0x58))
#define SMC5_MODE		((volatile unsigned int *)(0xFFFFEC00+0x5C))

/* oXRg[ݒp[^ */
#define AT91C_SM_NWE_SETUP		(1 << 0)
#define AT91C_SM_NCS_WR_SETUP	(0 << 8)
#define AT91C_SM_NRD_SETUP		(1 << 16)
#define AT91C_SM_NCS_RD_SETUP	(0 << 24)

#define AT91C_SM_NWE_PULSE 		(7 << 0)
#define AT91C_SM_NCS_WR_PULSE	(7 << 8)
#define AT91C_SM_NRD_PULSE		(7 << 16)
#define AT91C_SM_NCS_RD_PULSE	(7 << 24)
 
#define AT91C_SM_NWE_CYCLE 		(10 << 0)
#define AT91C_SM_NRD_CYCLE		(10 << 16)

#define AT91C_SMC_READMODE		(1 <<  0) // (SMC) Read Mode
#define AT91C_SMC_WRITEMODE		(1 <<  1) // (SMC) Write Mode
#define AT91C_SMC_NWAITM		(3 <<  5) // (SMC) NWAIT Mode

#define AT91C_SMC_NWAITM_NWAIT_DISABLE	(0x0 <<  5) // (SMC) External NWAIT disabled.
#define AT91C_SMC_DBW_WIDTH16	(0x1 << 12) // (SMC) 16 bits.
#define AT91C_SMC_DBW_WIDTH32	(0x2 << 12) // (SMC) 32 bits.

/* SDRAMRg[ */
#define SDRAM_BaseAddres		0x20000000
#define SDRAMC_MR		((volatile unsigned int *)(0xFFFFEA00+0x00))
#define SDRAMC_TR		((volatile unsigned int *)(0xFFFFEA00+0x04))
#define SDRAMC_CR		((volatile unsigned int *)(0xFFFFEA00+0x08))
#define SDRAMC_LPR		((volatile unsigned int *)(0xFFFFEA00+0x0C))
#define SDRAMC_IER		((volatile unsigned int *)(0xFFFFEA00+0x10))
#define SDRAMC_IDR		((volatile unsigned int *)(0xFFFFEA00+0x14))
#define SDRAMC_IMR		((volatile unsigned int *)(0xFFFFEA00+0x1C))
#define SDRAMC_ISR		((volatile unsigned int *)(0xFFFFEA00+0x20))
#define SDRAMC_MDR		((volatile unsigned int *)(0xFFFFEA00+0x24))

/* CCFG */
#define CCFG_EBICSA		((volatile unsigned int *)(0xFFFFEF10+0x0C))

/* SDRAMRg[ݒp[^ */
#define AT91C_SDRAMC_NC_9			(0x1) // (SDRAMC) 9 Bits
#define AT91C_SDRAMC_NR_13			(0x2 <<  2) // (SDRAMC) 13 Bits
#define AT91C_SDRAMC_CAS_2			(0x2 <<  5) // (SDRAMC) 2 cycles
#define AT91C_SDRAMC_NB_4_BANKS		(0x1 <<  4) // (SDRAMC) 4 banks
#define AT91C_SDRAMC_DBW_32_BITS	(0x0 <<  7) // (SDRAMC) 32 Bits datas bus
#define AT91C_SDRAMC_TWR_2			(0x2 <<  8) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRC_7			(0x7 << 12) // (SDRAMC) Value :  7
#define AT91C_SDRAMC_TRP_2			(0x2 << 16) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRCD_2			(0x2 << 20) // (SDRAMC) Value :  2
#define AT91C_SDRAMC_TRAS_5			(0x5 << 24) // (SDRAMC) Value :  5
#define AT91C_SDRAMC_TXSR_8			(0x8 << 28) // (SDRAMC) Value :  8

#define AT91C_SDRAMC_MODE_NORMAL_CMD	(0x0) // (SDRAMC) Normal Mode
#define AT91C_SDRAMC_MODE_NOP_CMD		(0x1) // (SDRAMC) Issue a NOP Command at every access
#define AT91C_SDRAMC_MODE_PRCGALL_CMD	(0x2) // (SDRAMC) Issue a All Banks Precharge Command at every access
#define AT91C_SDRAMC_MODE_LMR_CMD		(0x3) // (SDRAMC) Issue a Load Mode Register at every access
#define AT91C_SDRAMC_MODE_RFSH_CMD		(0x4) // (SDRAMC) Issue a Refresh
#define AT91C_SDRAMC_MODE_EXT_LMR_CMD	(0x5) // (SDRAMC) Issue an Extended Load Mode Register
#define AT91C_SDRAMC_MODE_DEEP_CMD		(0x6) // (SDRAMC) Enter Deep Power Mode

/* EHb`hbO^C}䃌WX^ */
#define WDT_MR			((volatile unsigned int *)(0xFFFFFD40+0x04))

/* ZbgRg[䃌WX^ */
#define RSTC_MR			((volatile unsigned int *)(0xFFFFFD00+0x08))

/* tbVRg[䃌WX^(EEFC) */
#define EEFC_FMR		((volatile unsigned int *)(0xFFFFFA00+0x00))

/* AhoXh荞݃Rg[(AIC) */
#define AIC_SMR0		((volatile unsigned int *)(0xFFFFF000+0x000))
#define AIC_SMR1		((volatile unsigned int *)(0xFFFFF000+0x004))
#define AIC_SMR2		((volatile unsigned int *)(0xFFFFF000+0x008))
#define AIC_SMR3		((volatile unsigned int *)(0xFFFFF000+0x00C))
#define AIC_SMR6		((volatile unsigned int *)(0xFFFFF000+0x018))
#define AIC_SMR7		((volatile unsigned int *)(0xFFFFF000+0x01C))
#define AIC_ISR			((volatile unsigned int *)(0xFFFFF000+0x108))
#define AIC_IPR			((volatile unsigned int *)(0xFFFFF000+0x10C))
#define AIC_IMR			((volatile unsigned int *)(0xFFFFF000+0x110))
#define AIC_IECR		((volatile unsigned int *)(0xFFFFF000+0x120))
#define AIC_IDCR		((volatile unsigned int *)(0xFFFFF000+0x124))
#define AIC_ICCR		((volatile unsigned int *)(0xFFFFF000+0x128))
#define AIC_ISCR		((volatile unsigned int *)(0xFFFFF000+0x12C))

#define	USE_UART_CH		1	/* UART`l0`1 */

#if (USE_UART_CH == 0)
	#define COM_BaseAdr		0xFFFB0000	/* USART0 */
#endif
#if (USE_UART_CH == 1)
	#define COM_BaseAdr		0xFFFB4000	/* USART1 */
#endif

#define COM_CR			((volatile unsigned int *)(COM_BaseAdr+0x00))
#define COM_MR			((volatile unsigned int *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned int *)(COM_BaseAdr+0x08))
#define COM_IDR			((volatile unsigned int *)(COM_BaseAdr+0x0C))
#define COM_IMR			((volatile unsigned int *)(COM_BaseAdr+0x10))
#define COM_CSR			((volatile unsigned int *)(COM_BaseAdr+0x14))
#define COM_RHR			((volatile unsigned int *)(COM_BaseAdr+0x18))
#define COM_THR			((volatile unsigned int *)(COM_BaseAdr+0x1C))
#define COM_BRGR		((volatile unsigned int *)(COM_BaseAdr+0x20))
#define COM_RTOR		((volatile unsigned int *)(COM_BaseAdr+0x24))
#define COM_TTGR		((volatile unsigned int *)(COM_BaseAdr+0x28))


/* PLLNbNn */
void pll_initialize(void)
{
	/* NbNn */
	*CKGR_MOR = 0x00004001;		/* COSCCl[u */
	while((*PMC_SR & 1)==0){}	/* CIV[^bN܂ő҂ */

	/* PLLAݒ [ MULA=97(0x61) / DIVA=9 ] */
	*CKGR_PLLAR = 0x2060BF09;	/* (18.432MHz*97)/9 = 198.656MHz */
	while((*PMC_SR & 2)==0){}	/* PLLAbN܂ő҂ */

	/* PCK = PLLA = 2 * MCK */
	*PMC_MCKR = 0x00000100;
	while((*PMC_SR & 8)==0){}	/* }X^NbNbN܂ő҂ */

	/* Switch MCK on PLLA output */
	*PMC_MCKR = 0x00000102;
	while((*PMC_SR & 8)==0){}	/* }X^NbNbN܂ő҂ */

	/* PLLBݒ [ MULB=73(0x49) / DIVA=14(0xE)] */
	*CKGR_PLLBR = 0x10483F0E;	/* (18.432MHz*73)/14 = 96.1MHz */
	while((*PMC_SR & 4)==0){}	/* PLLBbN܂ő҂ */

	*PMC_PCK0 = 1;			/* OoXNbN0o */
	*PMC_PCK1 = 1;			/* OoXNbN1o */
	*PMC_SCER = 0x3C;		/* PCK0/PCK1/UDP/UHPCl[u */
	*PMC_PCER = 0x1C;		/* PIO A~C NbNCl[u */
}


/* OoXRg[ */
void external_bus_initialize(void)
{
	/* f[^oX16rbgA */
	*PIOB_PDR = 0xC0000000;	/* PB31/PB30fBZ[u */
	*PIOB_ASR = 0xC0000000;	/* PCK1/PCK0 */
	*PIOC_PDR = 0xFFFFEFF0;	/* PCxxfBZ[u */
	*PIOC_ASR = 0xFFFFAF30;	/* D31~D16/NWAIT/FIQ/NCS2/A25/NCS5/NCS4/A24/A23 */
	*PIOC_BSR = 0x000040C0;	/* IRQ2/CFCE1/CFCE2 */
	*PMC_PCER = 0x10;		/* PIO C NbNCl[u */

	/* `bvZNg0oXRg[(16bit NOR Flash) */
	*SMC0_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC0_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC0_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC0_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM_NWAIT_DISABLE | AT91C_SMC_DBW_WIDTH16;

	/* `bvZNg2oXRg[(BLANCA) */
	*SMC2_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC2_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC2_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC2_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;

	/* `bvZNg4oXRg[(BLANCA) */
	*SMC4_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC4_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC4_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC4_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;

	/* `bvZNg5oXRg[(BLANCA) */
	*SMC5_SETUP = AT91C_SM_NWE_SETUP | AT91C_SM_NCS_WR_SETUP | AT91C_SM_NRD_SETUP | AT91C_SM_NCS_RD_SETUP;
	*SMC5_PLUSE = AT91C_SM_NWE_PULSE | AT91C_SM_NCS_WR_PULSE | AT91C_SM_NRD_PULSE | AT91C_SM_NCS_RD_PULSE;
	*SMC5_CYCLE = AT91C_SM_NWE_CYCLE | AT91C_SM_NRD_CYCLE;
	*SMC5_MODE  = AT91C_SMC_READMODE | AT91C_SMC_WRITEMODE | AT91C_SMC_NWAITM | AT91C_SMC_DBW_WIDTH32;
}


/* SDRAMԏ */
void sdram_write(unsigned int offset, unsigned int data)
{
	unsigned int *p;
	p=(unsigned int *)(SDRAM_BaseAddres + offset);
	*p=data;
}

/* SDRAMRg[SDRAM */
void sdram_initialize(void)
{
	int i;

	/* CCFG */
	*CCFG_EBICSA = (*CCFG_EBICSA | 0x00000002);	/* `bvZNg1 SDRAM */

	/* SDRAMR}hWX^ݒ */
	*SDRAMC_CR	= (AT91C_SDRAMC_NC_9 | AT91C_SDRAMC_NR_13 | AT91C_SDRAMC_CAS_2 | AT91C_SDRAMC_NB_4_BANKS | AT91C_SDRAMC_DBW_32_BITS | AT91C_SDRAMC_TWR_2 | AT91C_SDRAMC_TRC_7 | AT91C_SDRAMC_TRP_2 | AT91C_SDRAMC_TRCD_2 | AT91C_SDRAMC_TRAS_5 | AT91C_SDRAMC_TXSR_8);
	*SDRAMC_MDR	= 1;	/* [p[SDRAMݒ */

	for (i =0; i< 1000;i++){}	/* EFCg */

	*SDRAMC_MR  = AT91C_SDRAMC_MODE_NOP_CMD;	// Set NOP 
	sdram_write(0x00, 0x00000000);	// Perform NOP

	*SDRAMC_MR  = AT91C_SDRAMC_MODE_PRCGALL_CMD;// Set PRCHG AL
	sdram_write(0x00, 0x00000000);	// Perform PRCHG

	for (i =0; i< 10000;i++){}	/* EFCg */

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 1st CBR
	sdram_write(0x04, 0x00000001);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 2 CBR
	sdram_write(0x08, 0x00000002);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 3 CBR
	sdram_write(0x0C, 0x00000003);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 4 CBR
	sdram_write(0x10, 0x00000004);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 5 CBR
	sdram_write(0x14, 0x00000005);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 6 CBR
	sdram_write(0x18, 0x00000006);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 7 CBR
	sdram_write(0x1C, 0x00000007);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_RFSH_CMD;	// Set 8 CBR
	sdram_write(0x20, 0x00000008);	// Perform CBR

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_LMR_CMD;	// Set LMR operation
	sdram_write(0x24, 0xCAFEDEDE);	// Perform LMR burst=1, lat=2

	*SDRAMC_TR	= (MASTER_CLOCK * 7)/1000000;	// Set Refresh Timer

	*SDRAMC_MR	= AT91C_SDRAMC_MODE_NORMAL_CMD;	// Set Normal mode
	sdram_write(0x00, 0x00000000);	// Perform Normal mode
}

/* CPUŗL */
void CPU_Initialize(void)
{
  *WDT_MR   = 0x3FFFAFFF;	/* EHb`hbOfBZ[u */
  *RSTC_MR  = 0xA5000001;	/* ZbgSWZbgCl[u */
  *EEFC_FMR = 0x00000600;	/* tbVEFCgݒ */
  
  /* PLLNbNn */
  pll_initialize();
  
  /* OoXRg[ */
  external_bus_initialize();

  /* SDRAMRg[SDRAM */
  sdram_initialize();

}


// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case EXCEPTION_PREFETCH_ABORT:
    case EXCEPTION_DATA_ABORT:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case EXCEPTION_SOFTWARE:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case EXCEPTION_IRQ:
    case EXCEPTION_FIQ:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}


/* M荞݋ */
void enable_int(){
  *COM_IER = 1;			/* M荞 */
  //volatile unsigned int CPSR_val;
  //asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  //CPSR_val &= ~0x80;
  //asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* M荞݋֎~ */
void disable_int(){
  *COM_IER = 0;			/* M荞 */
  //volatile unsigned int CPSR_val;
  //asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  //CPSR_val |= 0x80;
  //asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* EHb`hbO^C}䃌WX^ */
#define WDT_CR			((volatile unsigned int *)(0xFFFFFD40+0x00))
#define WDT_MR			((volatile unsigned int *)(0xFFFFFD40+0x04))

/* AIC䃌WX^ */
#define AIC_SMR6		((volatile unsigned int *)(0xFFFFF000+0x018))
#define AIC_SMR7		((volatile unsigned int *)(0xFFFFF000+0x01C))
#define AIC_IECR		((volatile unsigned int *)(0xFFFFF000+0x120))

/* ZbgRg[ */
#define RSTC_CR 		((volatile unsigned int *)(0xFFFFF000+0xD00))
#define RSTC_SR 		((volatile unsigned int *)(0xFFFFF000+0xD04))
#define RSTC_MR 		((volatile unsigned int *)(0xFFFFF000+0xD08))

void gdb_stub_kill_command(){
  *RSTC_CR = 0xA5000005;
  while(1){}


  // EHb`hbN^C}[ŃtZbg
  *AIC_IECR = 0x2;
  *WDT_CR = 0x1;
  *WDT_MR   = 0x00012001;	/* EHb`hbOCl[u */
  
  while(1){}
}

// GDBgVA|[g܂B
void init_serial (){
#if (USE_UART_CH == 0)
  /* |[gUSART0[hɐݒ */
  *PIOB_PDR = 0x0C000030;	/* PB27/26/5/4fBZ[u */
  *PIOB_ASR = 0x0C000030;	/* TXD0/RXD0/RTS0/CTS0I */
  *PMC_PCER = *PMC_PCER | 0x40;	/* USART0NbNCl[u */
  *AIC_SMR6 = 7;			/* USART0 'H'x/荞݃x7 */
  *AIC_IECR = 0x40;		/* 荞݃Cl[u */
#endif
#if (USE_UART_CH == 1)
  /* |[gUSART1[hɐݒ */
  *PIOB_PDR = 0x300000C0;	/* PB29/28/7/6fBZ[u */
  *PIOB_ASR = 0x300000C0;	/* TXD1/RXD1/RTS1/CTS1I */
  *PMC_PCER = *PMC_PCER | 0x80;	/* USART1NbNCl[u */
  *AIC_SMR7 = 7;			/* USART1 'H'x/荞݃x7 */
  *AIC_IECR = 0x80;		/* 荞݃Cl[u */
#endif

  /* UARTݒ(MCK=98.304MHz) */
  *COM_CR  = 0x01AC;		/* e탊Zbg */
  *COM_MR  = 0x08C0;		/* m[}[h/1Stopbit/peB/8bitData */
  *COM_IDR = 0xFFFFFFFF;	/* 荞ݑSfBZ[u */
  *COM_BRGR= 53;			/* 115200bps ʐMxݒ */
  *COM_CR  = 0x0050;		/* MCl[u */
}


// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  unsigned char recv_data;

  while ((*COM_CSR & 1) == 0) {}	/* f[^M */
  recv_data = (unsigned char)*COM_RHR;	/* Mf[^ */  
  return recv_data;	/* Mf[^Ԃ */  
}

// 1M֐B
void putDebugChar (char ch){
  unsigned char status;
  while(1){
    status=*COM_CSR;	/* Xe[^X擾 */
    if (status & 2) {	/* Mobt@󂢂Ă邩 */
			/* 1oCg(data)M */
      *COM_THR=(unsigned int)ch;	/* Mf[^ */
      break;
    }
  }
}

void _illegalinst_func(void){
  gdb_handle_exception(EXCEPTION_ILL_INSN);
}

/* AhoXh荞݃Rg[(AIC) */
#define AIC_SMR0		((volatile unsigned int *)(0xFFFFF000+0x000))
#define AIC_SMR1		((volatile unsigned int *)(0xFFFFF000+0x004))
#define AIC_SMR2		((volatile unsigned int *)(0xFFFFF000+0x008))
#define AIC_SMR3		((volatile unsigned int *)(0xFFFFF000+0x00C))
#define AIC_SMR6		((volatile unsigned int *)(0xFFFFF000+0x018))
#define AIC_SMR7		((volatile unsigned int *)(0xFFFFF000+0x01C))
#define AIC_ISR			((volatile unsigned int *)(0xFFFFF000+0x108))
#define AIC_IPR			((volatile unsigned int *)(0xFFFFF000+0x10C))
#define AIC_IMR			((volatile unsigned int *)(0xFFFFF000+0x110))
#define AIC_IECR		((volatile unsigned int *)(0xFFFFF000+0x120))
#define AIC_IDCR		((volatile unsigned int *)(0xFFFFF000+0x124))
#define AIC_ICCR		((volatile unsigned int *)(0xFFFFF000+0x128))
#define AIC_ISCR		((volatile unsigned int *)(0xFFFFF000+0x12C))


void _int_func(void){
  unsigned int stat;

  //stat = *AIC_IPR;
  //	if (stat & 0x40) {	/* USART0荞ݗv */
  //  if (stat & 0x80) {	/* USART1荞ݗv */
  gdb_handle_exception(EXCEPTION_IRQ);
    //  }

}

void _bus_func(void){
  gdb_handle_exception(EXCEPTION_DATA_ABORT);
}

void cpu_init_at_main(){
  CPU_Initialize();
}


int IsAccesibleRAM(int addr){
  if(addr >= 0x00300000 && addr < 0x00308000)
    return 1;
  if(addr >= 0x20000000 && addr < 0x23F00000)
    return 1;
  return 0;
}

#define ARM_MODE 0
#define THUMB_MODE 1
volatile struct StepInst{
  int used;
  unsigned int InstTrue;
  unsigned int AddrTrue;
  unsigned int ModeTrue;
  unsigned int InstFalse;
  unsigned int AddrFalse;
  unsigned int ModeFalse;
} StepInstInfo;

void InitStep(){
  StepInstInfo.used = 0;
}


#define ILLEGAL_INST_ARM 0xe7ffdefe
#define ILLEGAL_INST_THUMB 0xbebe

extern registers[];

void RegisterStep(){
  unsigned int InstTmp;
  int cond, opcode, opcode_sub;
  int addr_offset;
  int CurrInstAddr;
  int Rd, Rm, Rn;
  int RnVal, RmVal;
  int DestAddr;
  int I_bit, P_bit, U_bit, W_bit, S_bit;
  int LoadAddr;
  int shift, shift_imm;
  int index, i;
  int C_flag;
  int shifter_operand;
  int rotate_imm;
  int Rs, RsVal;
  unsigned int LoadVal;
  int LRVal;
  int T_bit;

  CurrInstAddr = registers[PC];
  if((registers[CPSR] & (1<<5)) == 0)
    T_bit = 0;
  else
    T_bit = 1;


  // ============= THUMB[hŎsĂꍇ
  if(T_bit > 0){
    InstTmp = (unsigned int)(*((volatile unsigned short *)CurrInstAddr));

    if(((InstTmp>>12) & 0xF) == 0xd){ // B(1)
      addr_offset = InstTmp & 0xFF;
      if((addr_offset & (1<<7)) != 0)
	addr_offset |= ~0xFF;
      addr_offset <<= 1;

      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrFalse = CurrInstAddr + 2;
      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;


      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>11) & 0x1F) == 0x1C){ // B(2)
      addr_offset = InstTmp & 0x7FF;
      if((addr_offset & (1<<10)) != 0)
	addr_offset |= ~0x7FF;
      addr_offset <<= 1;    

      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrFalse = CurrInstAddr + 2;
      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>13) & 0x7) == 0x7 && ((InstTmp >> 11) & 0x3) != 0){ // BL, BLX (1)
      if(((InstTmp >> 11) & 0x3) == 2){ // H=10 2߂1߂̖߁BGCC̊֐Ăяoł͂g
	addr_offset = InstTmp & 0x7FF;
	if((addr_offset & (1<<10)) == 0) // g
	  addr_offset = (addr_offset << 12);
	else
	  addr_offset = (~0x7FF | addr_offset) << 12;
	InstTmp = (unsigned int)(*((volatile unsigned short *)(CurrInstAddr + 2)));
	unsigned int addr_offset2 = InstTmp & 0x7FF;
	addr_offset = addr_offset | (addr_offset2 << 1);
	if(((InstTmp >> 11) & 0x3) == 1) // H=01 (BLX)
	  addr_offset = (addr_offset & 0xFFFFFFFC);
	
	StepInstInfo.ModeFalse = THUMB_MODE; 
	StepInstInfo.AddrFalse = CurrInstAddr + 4;
	StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
	*((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 4;
	StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	StepInstInfo.used = 1;
	return;
      }
    }
    else if(((InstTmp>>7) & 0x1FF) == 0x8f){ // BLX (2)
      Rm = (InstTmp >> 3) & 0xF;
      // Read Rm
      RmVal = registers[Rm];

      StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

      StepInstInfo.ModeTrue = THUMB_MODE; 
      StepInstInfo.ModeFalse = THUMB_MODE; 
      StepInstInfo.AddrTrue = RmVal & 0xFFFFFFFE;
      StepInstInfo.AddrFalse = StepInstInfo.AddrTrue;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      StepInstInfo.InstFalse = StepInstInfo.InstTrue;
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      StepInstInfo.used = 1;
      return;
    }
    else if(((InstTmp>>7) & 0x1FF) == 0x8e){ // BX GCC͂Ŋ֐Ԃ
      Rm = (InstTmp >> 3) & 0xF;
      // Read Rm
      RmVal = registers[Rm];

      StepInstInfo.AddrTrue = RmVal & 0xFFFFFFFE;
      StepInstInfo.AddrFalse = StepInstInfo.AddrTrue;
      StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
      StepInstInfo.InstFalse = StepInstInfo.InstTrue;

      if((RmVal & 0x1) == 0){
	StepInstInfo.ModeTrue = ARM_MODE; 
	StepInstInfo.ModeFalse = ARM_MODE; 
	*((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      }
      else{
	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.ModeFalse = THUMB_MODE; 
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      }
      StepInstInfo.used = 1;
      return;
    }
    else if((InstTmp>>8) == 0x46){ // MOV (3)
      if((InstTmp & (1<<7)) != 0 && ((InstTmp & 0x7) == 0x7)){ // PC
	Rm = ((InstTmp >> 3) & 0x7);
	if((InstTmp & (1<<6)) != 0)
	  Rm += 8;
	// Read Rm
	RmVal = registers[Rm];

	StepInstInfo.ModeFalse = THUMB_MODE; 
	StepInstInfo.AddrFalse = CurrInstAddr + 2;
	StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
	*((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;

	StepInstInfo.ModeTrue = THUMB_MODE; 
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	StepInstInfo.AddrTrue = RmVal;
	StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	StepInstInfo.used = 1;
	return;
      }
    }

    StepInstInfo.ModeFalse = THUMB_MODE; 
    StepInstInfo.AddrFalse = CurrInstAddr + 2;
    StepInstInfo.InstFalse = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrFalse));
    *((volatile unsigned short *)StepInstInfo.AddrFalse) = ILLEGAL_INST_THUMB;



    StepInstInfo.ModeTrue = THUMB_MODE; 
    StepInstInfo.AddrTrue = StepInstInfo.AddrFalse;
    StepInstInfo.InstTrue = StepInstInfo.InstFalse;
    StepInstInfo.used = 1; 

  }
  // ==================== ARM[hŎsĂꍇ
  else{ // T_bit == 0
    InstTmp = *((volatile unsigned int *)CurrInstAddr);

    cond = (InstTmp >> 28) & 0xF;
    opcode = (InstTmp >> 24) & 0xF;
    opcode_sub = (InstTmp >> 20) & 0xF;
  
    StepInstInfo.ModeFalse = ARM_MODE; 
    StepInstInfo.AddrFalse = CurrInstAddr + 4;
    StepInstInfo.InstFalse = *((volatile unsigned int *)StepInstInfo.AddrFalse);
    *((volatile unsigned int *)StepInstInfo.AddrFalse) = ILLEGAL_INST_ARM;


    if((opcode & 0xE) == 0xA){ // B
      if((InstTmp & (1<<23)) == 0) // rbg0
	addr_offset = (InstTmp & 0xFFFFFF) << 2;
      else // rbg1
	addr_offset = ((InstTmp & 0xFFFFFF) | 0xFF000000) << 2;

      if(cond == 0xF){ // BLX(1)̂Ƃ(BLX func_label)
	if((opcode & 0x1) != 0) // H == 1
	  addr_offset |= 0x2;
	else
	  addr_offset &= ~0x2;
      }

      StepInstInfo.ModeTrue = ARM_MODE; 
      StepInstInfo.AddrTrue = CurrInstAddr + addr_offset + 8;
      StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      StepInstInfo.used = 1;
      return;
    }
    else if((opcode & 0xE) == 0x8 && (opcode_sub & 0x1) == 0x1){ // LDM (1) or LDM (3) GCCłreturn͑SĂB LDM sp, {r11, sp, pc}
      if((InstTmp & (1<<15)) != 0){ // PCXgɂ
	Rn = ((InstTmp >> 16) & 0xF);
	addr_offset = 0;
	for(i=0;i<15;i++){ // r0-r14
	  if((InstTmp & (1<<i)) != 0)
	    addr_offset += 4;
	}
	// Read Rn
	RnVal = registers[Rn];
	RnVal = *((unsigned int *)(RnVal + addr_offset));
	StepInstInfo.AddrTrue = RnVal & 0xFFFFFFFE;
	if((RnVal & 0x1) == 0){
	  StepInstInfo.ModeTrue = ARM_MODE; 
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	}
	else{
	  StepInstInfo.ModeTrue = THUMB_MODE; 
	  StepInstInfo.InstTrue = (short)*((volatile unsigned short *)StepInstInfo.AddrTrue);
	  *((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	}
	StepInstInfo.used = 1;
	return;
      }
    }
    else if(opcode == 0x1 && opcode_sub == 0x2){ // BX, BLX(2)
      Rd = InstTmp & 0xF;
      // Read Rd
      RmVal = registers[Rm];
      StepInstInfo.AddrTrue = DestAddr & 0xFFFFFFFE;
      if((DestAddr & 0x1) != 0){ // To Thumb
	StepInstInfo.ModeTrue = THUMB_MODE; 
	StepInstInfo.InstTrue = *((volatile unsigned short *)StepInstInfo.AddrTrue);
	*((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
      }
      else { // To ARM
	StepInstInfo.ModeTrue = ARM_MODE; 
	StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	*((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
      }
      StepInstInfo.used = 1;
      return;
    }
    else if((opcode & 0xd) != 0x1 && (opcode_sub & 0xe) == 0xc){ // MOV
      Rd = (InstTmp>>12) & 0xF;
      if(Rd == 15){ // PĈƂ
	I_bit = 0;
	S_bit = 0;
	if((InstTmp & (1<<25)) == 0)
	  I_bit = 1;
	if((InstTmp & (1<<20)) == 0)
	  S_bit = 1;
      
	if(I_bit == 1){
	  shifter_operand = (InstTmp & 0xFF);
	  rotate_imm = ((InstTmp>>8) & 0xF);
	  for(i=0;i<rotate_imm;i++){ // E[e[g
	    shifter_operand = ((shifter_operand & 0x1)<<31) & (shifter_operand >> 1);
	  }
	}
	else{ // I_bit == 0
	  if(((InstTmp>>4) & 0x7) == 0){
	    shift_imm = (InstTmp>>7) & 0x1F;

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    shifter_operand = RmVal << shift_imm;
	  }
	  else if(((InstTmp>>4) & 0x7) == 1){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal << (RsVal & 0xFF);
	    else
	      shifter_operand = 0;
	  }
	  else if(((InstTmp>>4) & 0x7) == 2){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0)
	      shifter_operand = 0;
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }
	  else if(((InstTmp>>4) & 0x7) == 3){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal >> (RsVal & 0xFF);
	    else
	      shifter_operand = 0;	  
	  }	
	  else if(((InstTmp>>4) & 0x7) == 4){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0){
	      if((RmVal & (1<<31)) == 0)
		shifter_operand = 0;	  
	      else
		shifter_operand = 0xFFFFFFFF;
	    }
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }	
	  else if(((InstTmp>>4) & 0x7) == 5){
	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) == 0)
	      shifter_operand = RmVal;
	    else if((RsVal & 0xFF) < 32)
	      shifter_operand = RmVal >> (RsVal & 0xFF);
	    else{
	      if((RmVal & (1<<31)) == 0)
		shifter_operand = 0;
	      else
		shifter_operand = 0xFFFFFFFF;
	    }
	  }	
	  else if(((InstTmp>>4) & 0x7) == 6){
	    shift_imm = (InstTmp>>7) & 0x1F;
	    // Read C flag
	    C_flag = (registers[CPSR] >> 29) & 0x1;
	  
	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if(shift_imm == 0)
	      shifter_operand = C_flag << 31 | (RmVal >> 1);
	    else
	      shifter_operand = RmVal >> shift_imm;
	  }	
	  else if(((InstTmp>>4) & 0x7) == 7){
	    // Read C flag
	    C_flag = (registers[CPSR] >> 29) & 0x1;

	    Rs = (InstTmp>>8) & 0xF;
	    // Read Rs
	    RsVal = registers[Rs];

	    Rm = InstTmp & 0xF;
	    // Read RmVal
	    RmVal = registers[Rm];

	    if((RsVal & 0xFF) == 0)
	      shifter_operand = RmVal;
	    else
	      if((RsVal & 0xF) == 0)
		shifter_operand = RmVal;
	      else{
		for(i=0;i<(RsVal & 0xF);i++){ // E[e[g
		  RmVal = ((RmVal & 0x1)<<31) & (RmVal >> 1);
		}
		shifter_operand = RmVal;
	      }
	  }

	  StepInstInfo.AddrTrue = shifter_operand;
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	  StepInstInfo.used = 1;
	  return;
	}
      }
    }
    else if((opcode & 0xc) != 0x4 && (opcode_sub & 0x5) == 0x1){ // LDR
      Rd = (InstTmp>>12) & 0xF;
      if(Rd == 15){ // PĈƂ
	I_bit = 0;
	P_bit = 0;
	U_bit = 0;
	W_bit = 0;
	if((InstTmp & (1<<25)) == 0)
	  I_bit = 1;
	if((InstTmp & (1<<24)) == 0)
	  P_bit = 1;
	if((InstTmp & (1<<23)) == 0)
	  U_bit = 1;
	if((InstTmp & (1<<21)) == 0)
	  W_bit = 1;

	if(I_bit == 0){
	  Rn = (InstTmp>>16) & 0xF;
	  // Read Rn
	  RnVal = registers[Rn];
	
	  if(W_bit == 0){
	    if(Rn == 15) // PC
	      RnVal += 8;
	  }

	  addr_offset = InstTmp & 0xFFF;
	  if(U_bit == 1)
	    LoadAddr = RnVal + addr_offset;
	  else
	    LoadAddr = RnVal - addr_offset;
	}
	else if(I_bit == 1){
	  if(((InstTmp>>4) & 0xFF) == 0){
	    Rn = (InstTmp>>16) & 0xF;
	    // Read Rn
	    RnVal = registers[Rn];
	  
	    if(W_bit == 0){
	      if(Rn == 15) // PC
		RnVal += 8;
	    }

	    Rm = InstTmp & 0xF;
	    // Read Rm
	    RmVal = registers[Rm];
	  
	    if(U_bit == 1)
	      LoadAddr = RnVal + RmVal;
	    else
	      LoadAddr = RnVal - RmVal;
	  }
	  else {
	    Rn = (InstTmp>>16) & 0xF;
	    // Read Rn
	    RnVal = registers[Rn];
	  
	    if(Rn == 15) // PC
	      RnVal += 8;
	  
	    Rm = InstTmp & 0xF;
	    // Read Rm
	    RmVal = registers[Rm];
	  
	    shift = (InstTmp >> 5) & 0x3;
	    shift_imm = (InstTmp >> 7) & 0x1F;
	    switch(shift){
	    case 0:
	      index = RmVal << shift_imm;
	      break;
	    case 1:
	      if(shift_imm == 0) index = 0;
	      else
		index = ((unsigned int)RmVal) >> shift_imm;
	      break;
	    case 2:
	      if(shift_imm == 0){
		if((RmVal & (1<<31)) != 0)
		  index = 0xFFFFFFFF;
		else
		  index = 0;
	      }
	      else
		index = RmVal >> shift_imm;
	      break;
	    case 3:
	      if(shift_imm == 0){
		// Read C flag
		C_flag = (registers[CPSR] >> 29) & 0x1;
		
		index = (C_flag << 31) | (((unsigned int)RmVal) >> 1);
	      }
	      else{
		for(i=0;i<shift_imm;i++){ // E[e[g
		  RmVal = ((RmVal & 0x1)<<31) & (RmVal >> 1);
		}
	      }
	    }
	    if(U_bit == 1)
	      LoadAddr = RnVal + index;
	    else
	      LoadAddr = RnVal - index;
	  }
	}
      
	if((LoadAddr & 0x3) == 0){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	}
	else if((LoadAddr & 0x3) == 1){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<8;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	}
	else if((LoadAddr & 0x3) == 2){
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<16;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	}
	else { // 3
	  LoadVal = *((volatile unsigned int *)LoadAddr);
	  for(i=0;i<24;i++){ // E[e[g
	    LoadVal = ((LoadVal & 0x1)<<31) & (LoadVal >> 1);
	  }
	} 
      
	StepInstInfo.AddrTrue = LoadVal & 0xFFFFFFFE;
	if((LoadVal & 0x1) != 0){
	  *((volatile unsigned short *)StepInstInfo.AddrTrue) = ILLEGAL_INST_THUMB;
	  StepInstInfo.ModeTrue = THUMB_MODE;
	  StepInstInfo.InstTrue = (unsigned int)(*((volatile unsigned short *)StepInstInfo.AddrTrue));
	}
	else{
	  *((volatile unsigned int *)StepInstInfo.AddrTrue) = ILLEGAL_INST_ARM;
	  StepInstInfo.ModeTrue = ARM_MODE;
	  StepInstInfo.InstTrue = *((volatile unsigned int *)StepInstInfo.AddrTrue);
	}
	StepInstInfo.used = 1;
	return;
      }
    }

    StepInstInfo.ModeTrue = ARM_MODE; 
    StepInstInfo.AddrTrue = StepInstInfo.AddrFalse;
    StepInstInfo.InstTrue = StepInstInfo.InstFalse;
    StepInstInfo.used = 1; 
  }
}


void DeRegisterStep(){
  unsigned int CurrAddr;

  CurrAddr = registers[PC];

  if(StepInstInfo.used != 0){
    if(StepInstInfo.ModeTrue == ARM_MODE)
      *((volatile unsigned int *)StepInstInfo.AddrTrue) = StepInstInfo.InstTrue;
    else
      *((volatile unsigned short *)StepInstInfo.AddrTrue) = (unsigned short)(StepInstInfo.InstTrue);
      
    if(StepInstInfo.ModeFalse == ARM_MODE)
      *((volatile unsigned int *)StepInstInfo.AddrFalse) = StepInstInfo.InstFalse;
    else
      *((volatile unsigned short *)StepInstInfo.AddrFalse) = (unsigned short)(StepInstInfo.InstFalse);
      
    StepInstInfo.used = 0;
  }
}
