	.text

	.extern		main
	.extern		_sp_base
	.extern		_save_registers
	.extern		monitor
#======================================
#      Initialize vectors
#
##     0x00 	 Reset
##     0x04 	 Undefined Instruction
##     0x08 	 Software Interrupt
##     0x0c 	 Abort(prefetch)
##     0x10 	 Abort(data)
##     0x14 	 Reserved
##     0x18 	 IRQ
##     0x1c 	 FIQ
#======================================

	B	_startup
	nop
	nop
	nop
	nop
	nop
	B	_IRQ_handle
	nop
	.org 0x20	
	.global _startup
_startup:
	# dataZNVROM->RAMRs[
        LDR     r1, =_sdata_loadaddr
        LDR     r2, =_sdata
        LDR     r3, =_edata
__copy_loop:
        LDRB    r4, [r1]
        STRB    r4, [r2, #0]
        ADD     r1, r1, #1
        ADD     r2, r2, #1
        CMP     r3, r2
        BGT     __copy_loop
	# bss0ŏ
        LDR     r1, =_sbss
        LDR     r2, =_ebss
	LDR	r3, =0x0
__bss_init_loop:
        STRB    r3, [r1, #0]
        ADD     r1, r1, #1
        CMP     r2, r1
        BGT     __bss_init_loop
	
	#IRQʒm󂯎悤ɐݒ肷
	MRS	R0, cpsr
	eor	R0, R0, #0x80
	MSR	cpsr, R0
	#vZbT[hIRQ[h	
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
	#OnhpX^bNݒ
	LDR	sp, = _exception_sp_base

	#vZbT[hX[p[oCU[h֖߂
	MRS	r1, CPSR
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

	# X^bNݒ
	LDR	R13,=_sp_base
.ifdef THUMB
	LDR     R1,=main
	ORR     R1, R1 ,#1
	BX      R1
.else
	BL	main
.endif
	.align 0x4
_IRQ_handle:
	#OpX^bNɃWX^ޔ	
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

	bl	_save_registers
	bl	monitor
		
	#OpX^bN烌WX^A	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
		
	SUBS	PC, R14, #4
