#ifndef __GDB_STUB_COMMON_H
#define __GDB_STUB_COMMON_H

typedef void (*Function) ();

// u[N|Cgێ\
struct breakpoint_list {
  int used; // gpĂ邩ǂB1̂Ƃp
  unsigned int addr; //@u[ÑAhX
  unsigned int inst; // ̖
};

void putDebugChar (char);
char getDebugChar (void);

#define TARGET_SIGNAL_INT 2
#define TARGET_SIGNAL_ILL 4
#define TARGET_SIGNAL_TRAP 5
#define TARGET_SIGNAL_BUS 10
#define TARGET_SIGNAL_SYS 12
#define TARGET_SIGNAL_TERM 15

char * strcpy(char *dest, const char *src);
int computeSignal (int exceptionVector);
void clear_uart();
void enable_int();
void disable_int();
void init_serial ();
char getDebugChar (void);
void putDebugChar (char ch);
void cpu_init_at_main();
void gdb_stub_kill_command();
void handle_exception(int exceptionVector);
void UBC_clr(unsigned int addr);
int UBC_set(unsigned int addr);
int IsAccesibleRAM(int addr);
void InitStep();
void RegisterStep();
void DeRegisterStep();

#endif /*__GDB_STUB_COMMON_H*/
