	.text

	.extern		_main
#===============================
#      SH-2A Exception Vector
#===============================
	#PowerON reset
	.long	_startup
	.long	_sp_base
	.org	0x0008
	#Manual reset
	.long	_startup
	.long	_sp_base
	.org	0x0010
	# Illegal instruction
	.long	_undefined_instruction_exception
	.long	0x00000000
	.org	0x0018
	# Illegal Slot
	.long	_illegalslot_exception
	.long	0x00000000
	.long	0xC91F0606
	.org	0x0024
	# CPU address Error
	.long	_addresserror_exception
	.org	0x0028
	# DMA address Error
	.long	_dmaaddresserror_exception
	.org	0x002C
	# NMI
	.long	_nmi_exception
	.org	0x0030
	# User Break
	.long	_userbreak_exception
	.org	0x0034
	# FPU
	.long	_fpu_exception
	.org	0x0038
	# H-UDH
	.long	_hudi_exception
	.org	0x003C
	# BANK Overflow
	.long	_bankof_exception
	.org	0x0040
	# BANK Underflow
	.long	_bankuf_exception
	.org	0x0044
	# DIV0
	.long	_div0_exception
	.org	0x0048
	# Int Div Overflow
	.long	_intdiv_exception
	.org	0x0080
	#TRAP32 // This is reserved by this GDB stub. Used for TRAPA #32
	.long	_userbreak_exception
	#TRAP33
	.long	_trap33_exception
	#TRAP34
	.long	_trap34_exception
	#TRAP35
	.long	_trap35_exception
	#TRAP36
	.long	_trap36_exception
	#TRAP37
	.long	_trap37_exception
	#TRAP38
	.long	_trap38_exception
	#TRAP39
	.long	_trap39_exception
	#TRAP40
	.long	_trap40_exception
	#TRAP41
	.long	_trap41_exception
	#TRAP42
	.long	_trap42_exception
	#TRAP43
	.long	_trap43_exception
	#TRAP44
	.long	_trap44_exception
	#TRAP45
	.long	_trap45_exception
	#TRAP46
	.long	_trap46_exception
	#TRAP47
	.long	_trap47_exception
	#TRAP48
	.long	_trap48_exception
	#TRAP49
	.long	_trap49_exception
	#TRAP50
	.long	_trap50_exception
	#TRAP51
	.long	_trap51_exception
	#TRAP52
	.long	_trap52_exception
	#TRAP53
	.long	_trap53_exception
	#TRAP54
	.long	_trap54_exception
	#TRAP55
	.long	_trap55_exception
	#TRAP56
	.long	_trap56_exception
	#TRAP57
	.long	_trap57_exception
	#TRAP58
	.long	_trap58_exception
	#TRAP59
	.long	_trap59_exception
	#TRAP60
	.long	_trap60_exception
	#TRAP61
	.long	_trap61_exception
	#TRAP62
	.long	_trap62_exception
	#TRAP63
	.long	_trap63_exception
	.org	0x0100
	#IRQ0
	.long	_irq0_exception
	#IRQ1
	.long	_irq1_exception
	#IRQ2
	.long	_irq2_exception
	#IRQ3
	.long	_irq3_exception
	#IRQ4
	.long	_irq4_exception
	#IRQ5
	.long	_irq5_exception
	#IRQ6
	.long	_irq6_exception
	#IRQ7
	.long	_irq7_exception
	.org	0x140
	#PINT0
	.long	_pint0_exception
	#PINT1
	.long	_pint1_exception
	#PINT2
	.long	_pint2_exception
	#PINT3
	.long	_pint3_exception
	#PINT4
	.long	_pint4_exception
	#PINT5
	.long	_pint5_exception
	#PINT6
	.long	_pint6_exception
	#PINT7
	.long	_pint7_exception
	
	.org	0x30C
	#TRAP 195 "0xc3c3"
	.long	_break_exception

	/* UART0 */
	.org	0x3A0
	.long	_BRI0_exception
	.long	_ERI0_exception
	.long	_RXI0_exception
	.long	_TXI0_exception
	/* UART1 */
	.org	0x3B0
	.long	_BRI1_exception
	.long	_ERI1_exception
	.long	_RXI1_exception
	.long	_TXI1_exception
	/* UART2 */
	.org	0x3C0
	.long	_BRI2_exception
	.long	_ERI2_exception
	.long	_RXI2_exception
	.long	_TXI2_exception
	/* UART3 */
	.org	0x3D0
	.long	_BRI3_exception
	.long	_ERI3_exception
	.long	_RXI3_exception
	.long	_TXI3_exception

	.org	0x500
		
	.align 4
_startup:
	#荞ݗDx10ɉ
	stc	sr,r1
	mov	#0xF0, r2
	not	r2,r2
	and	r2,r1
	add	#0xA0,r1
	ldc	r1,sr
	
	mov.l	_start_addr_list,r1
	jmp	@r1
	nop

	.align 4
_start_addr_list:
	.long	_main
_data_section_start_addr:
	.long	_sdata
_data_section_end_addr:
	.long	_edata
#_ram_base_addr:
#	.long	_sdata_va

	.extern stub_stack
	.extern registers
	.extern __illegalinst_func
	.extern __rxint_func

_break_exception:
	#PC,SRȊÕWX^X^bNɑޔ
	sts.l	macl,@-r15
	sts.l	mach,@-r15
	stc.l	vbr,@-r15
	stc.l	gbr,@-r15
	sts.l	pr,@-r15
	mov.l	r14,@-r15
	mov.l	r13,@-r15
	mov.l	r12,@-r15
	mov.l	r11,@-r15
	mov.l	r10,@-r15
	mov.l	r9,@-r15
	mov.l	r8,@-r15
	mov.l	r7,@-r15
	mov.l	r6,@-r15
	mov.l	r5,@-r15
	mov.l	r4,@-r15
	mov.l	r3,@-r15
	mov.l	r2,@-r15
	mov.l	r1,@-r15
	mov.l	r0,@-r15

	#WX^L^
	#X^bNǂݕԂ
	mov.l	_registers_addr_ill, r1
	mov	r15,r2
	#r0
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r1
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r2
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r3
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r4
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r5
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r6
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r7
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r8
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r9
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r10
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r11
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r12
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r13
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r14
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r15݂͌spޔWX^𑫂
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	r5,@r1
	add	#4,r1	
	#PC͗Oɑޔꂽ̂ǂݏo
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4,r3
	add	#-2, r3
	mov.l	r3,@r1
	add	#4,r1
	#pr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#gbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#vbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#mach
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#macl
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#sr̓X^bNǂݏo
	mov	#84,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4, r6
	mov.l	r6,@r1
	
	mov.l	_illegalinst_func_addr, r1
	jsr	@r1
	nop
	
	#PC,SRȊÕWX^X^bN畜A
	mov.l	@r15+,r0
	mov.l	@r15+,r1
	mov.l	@r15+,r2
	mov.l	@r15+,r3
	mov.l	@r15+,r4
	mov.l	@r15+,r5
	mov.l	@r15+,r6
	mov.l	@r15+,r7
	mov.l	@r15+,r8
	mov.l	@r15+,r9
	mov.l	@r15+,r10
	mov.l	@r15+,r11
	mov.l	@r15+,r12
	mov.l	@r15+,r13
	mov.l	@r15+,r14
	lds.l	@r15+,pr
	ldc.l	@r15+,gbr
	ldc.l	@r15+,vbr
	lds.l	@r15+,mach
	lds.l	@r15+,macl
	# O烊^[
	RTE
	nop

	.align	0x4
_illegalinst_func_addr:
	.long	__illegalinst_func
_registers_addr_ill:
	.long	_registers

	.align	0x4
_undefined_instruction_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x10, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_illegalslot_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x18, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_addresserror_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x24, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_dmaaddresserror_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x28, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_nmi_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x2C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_userbreak_exception:
#	mov.l	r1,@-r15
#	mov.l	_user_vbr_addr, r1
#	mov.l	@r1, r1
#	add	#0x30, r1
#	mov.l	@r1, r1
#	jmp	@r1
#	mov.l	@r15+,r1

	#PC,SRȊÕWX^X^bNɑޔ
	sts.l	macl,@-r15
	sts.l	mach,@-r15
	stc.l	vbr,@-r15
	stc.l	gbr,@-r15
	sts.l	pr,@-r15
	mov.l	r14,@-r15
	mov.l	r13,@-r15
	mov.l	r12,@-r15
	mov.l	r11,@-r15
	mov.l	r10,@-r15
	mov.l	r9,@-r15
	mov.l	r8,@-r15
	mov.l	r7,@-r15
	mov.l	r6,@-r15
	mov.l	r5,@-r15
	mov.l	r4,@-r15
	mov.l	r3,@-r15
	mov.l	r2,@-r15
	mov.l	r1,@-r15
	mov.l	r0,@-r15

	#WX^L^
	#X^bNǂݕԂ
	mov.l	_registers_addr_break, r1
	mov	r15,r2
	#r0
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r1
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r2
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r3
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r4
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r5
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r6
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r7
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r8
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r9
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r10
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r11
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r12
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r13
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r14
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r15݂͌spޔWX^𑫂
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	r5,@r1
	add	#4,r1	
	#PC͗Oɑޔꂽ̂ǂݏo
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4,r3
	mov.l	r3,@r1
	add	#4,r1
	#pr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#gbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#vbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#mach
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#macl
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#sr̓X^bNǂݏo
	mov	#84,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4, r6
	mov.l	r6,@r1
	
	mov.l	_break_func_addr, r1
	jsr	@r1
	nop
	
	#PC,SRȊÕWX^X^bN畜A
	mov.l	@r15+,r0
	mov.l	@r15+,r1
	mov.l	@r15+,r2
	mov.l	@r15+,r3
	mov.l	@r15+,r4
	mov.l	@r15+,r5
	mov.l	@r15+,r6
	mov.l	@r15+,r7
	mov.l	@r15+,r8
	mov.l	@r15+,r9
	mov.l	@r15+,r10
	mov.l	@r15+,r11
	mov.l	@r15+,r12
	mov.l	@r15+,r13
	mov.l	@r15+,r14
	lds.l	@r15+,pr
	ldc.l	@r15+,gbr
	ldc.l	@r15+,vbr
	lds.l	@r15+,mach
	lds.l	@r15+,macl
	# O烊^[
	RTE
	nop
_fpu_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x34, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
	
_hudi_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x38, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1

_bankof_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x3C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1

_bankuf_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1

_div0_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x04, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1

_intdiv_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x08, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1

	#TRAP32GDBX^uŎĝŎgp֎~
#_trap32_exception:
#	mov.l	r1,@-r15
#	mov.l	_user_vbr_addr, r1
#	mov.l	@r1, r1
#	add	#0x40, r1
#	add	#0x40, r1
#	mov.l	@r1, r1
#	jmp	@r1
#	mov.l	@r15+,r1
_trap33_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x44, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap34_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x48, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap35_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x4C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap36_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x50, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap37_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x54, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap38_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x58, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap39_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x5C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap40_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x60, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap41_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x64, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap42_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x68, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap43_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x6C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap44_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x70, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap45_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x74, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap46_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x78, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap47_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x7C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap48_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap49_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x04, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap50_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x08, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap51_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x0C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap52_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x10, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap53_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x14, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap54_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x18, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap55_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x1C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap56_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x20, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap57_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x24, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap58_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x28, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap59_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x2C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap60_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x30, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap61_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x34, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1
	.align	0x4
_user_vbr_addr:	
	.long	_user_exception_vector_addr
_break_func_addr:
	.long	__illegalinst_func
_registers_addr_break:
	.long	_registers
_trap62_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x38, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_trap63_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x3C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
	.align	0x4
_irq0_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1
_irq1_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x04, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq2_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x08, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq3_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x0C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq4_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x10, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq5_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x14, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq6_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x18, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_irq7_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x1C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	

_pint0_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint1_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x04, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint2_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x08, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint3_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x0C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint4_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x10, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint5_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x14, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint6_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x18, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_pint7_exception:
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr2, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x1C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	

_user_vbr_addr2:
	.long	_user_exception_vector_addr
	
_BRI0_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x20, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_ERI0_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x24, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_RXI0_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x28, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_TXI0_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x2C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	






_BRI1_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x30, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_ERI1_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x34, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_RXI1_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x38, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_TXI1_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x3C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	






_BRI2_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_ERI2_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x04, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_TXI2_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr3, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x0C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	

	.align	0x4
_user_vbr_addr3:
	.long	_user_exception_vector_addr


_RXI2_exception:
	#PC,SRȊÕWX^X^bNɑޔ
	sts.l	macl,@-r15
	sts.l	mach,@-r15
	stc.l	vbr,@-r15
	stc.l	gbr,@-r15
	sts.l	pr,@-r15
	mov.l	r14,@-r15
	mov.l	r13,@-r15
	mov.l	r12,@-r15
	mov.l	r11,@-r15
	mov.l	r10,@-r15
	mov.l	r9,@-r15
	mov.l	r8,@-r15
	mov.l	r7,@-r15
	mov.l	r6,@-r15
	mov.l	r5,@-r15
	mov.l	r4,@-r15
	mov.l	r3,@-r15
	mov.l	r2,@-r15
	mov.l	r1,@-r15
	mov.l	r0,@-r15

	#WX^L^
	#X^bNǂݕԂ
	mov.l	_registers_addr_rxint, r1
	mov	r15,r2
	#r0
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r1
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r2
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r3
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r4
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r5
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r6
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r7
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r8
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r9
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r10
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r11
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r12
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r13
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r14
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#r15݂͌spޔWX^𑫂
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	r5,@r1
	add	#4,r1	
	#PC͗Oɑޔꂽ̂ǂݏo
	mov	#80,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4,r3
	mov.l	r3,@r1
	add	#4,r1
	#pr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#gbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#vbr
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#mach
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#macl
	mov.l	@r2+,r3
	mov.l	r3,@r1
	add	#4,r1
	#sr̓X^bNǂݏo
	mov	#84,r4
	mov	r15,r5
	add	r5,r4
	mov.l	@r4, r6
	mov.l	r6,@r1
	
	mov.l	_rxint_func_addr, r1	
	jsr	@r1
	nop
	
	#PC,SRȊÕWX^X^bN畜A
	mov.l	@r15+,r0
	mov.l	@r15+,r1
	mov.l	@r15+,r2
	mov.l	@r15+,r3
	mov.l	@r15+,r4
	mov.l	@r15+,r5
	mov.l	@r15+,r6
	mov.l	@r15+,r7
	mov.l	@r15+,r8
	mov.l	@r15+,r9
	mov.l	@r15+,r10
	mov.l	@r15+,r11
	mov.l	@r15+,r12
	mov.l	@r15+,r13
	mov.l	@r15+,r14
	lds.l	@r15+,pr
	ldc.l	@r15+,gbr
	ldc.l	@r15+,vbr
	lds.l	@r15+,mach
	lds.l	@r15+,macl
	# O烊^[
	RTE
	nop

	.align 4
_registers_addr_rxint:
	.long	_registers
_rxint_func_addr:
	.long __int_func

_BRI3_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr4, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x10, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_ERI3_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr4, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x14, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_RXI3_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr4, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x18, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	
_TXI3_exception:	
	mov.l	r1,@-r15
	mov.l	_user_vbr_addr4, r1
	mov.l	@r1, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	
	add	#0x40, r1
	add	#0x40, r1
	add	#0x40, r1
	add	#0x1C, r1
	mov.l	@r1, r1
	jmp	@r1
	mov.l	@r15+,r1	


_user_vbr_addr4:
	.long	_user_exception_vector_addr
