/* SH2A72623newlibTvvO*/
/* Copyright (c) Shinichi Yamagiwa */
/* LED_łȂUARTGR[obN܂*/

#include <stdio.h>

/* NbNݒRg[䃌WX^ */
#define FRQCR	*((volatile unsigned short int *)(0xFFFE0010))

/* UARTRg[ */
#define	USE_BPS		38400	/* ʐMx 19200 or 38400 */
#define	USE_UART_CH		2	/* UART`l2 or 3 */

#if (USE_BPS == 38400)
#define SCBRR_SET 19
#endif
#if (USE_BPS == 19200)
#define SCBRR_SET 38
#endif

#if (USE_UART_CH == 0)
/* FIFOtVARg[SCIF(SCIF0) */
#define UartBaseAddr (0xFFFE8000)
#endif
#if (USE_UART_CH == 2)
/* FIFOtVARg[SCIF(SCIF2) */
#define UartBaseAddr (0xFFFE9000)
#endif
#if (USE_UART_CH == 3)
/* FIFOtVARg[SCIF(SCIF3) */
#define UartBaseAddr (0xFFFE9800)
#endif

/* FIFOtVARg[SCIF(SCIFx) */
#define SCSMR	*((volatile unsigned short int *)(UartBaseAddr+0x000))
#define SCBRR	*((volatile unsigned char      *)(UartBaseAddr+0x004))
#define SCSCR	*((volatile unsigned short int *)(UartBaseAddr+0x008))
#define SCFTDR	*((volatile unsigned char      *)(UartBaseAddr+0x00C))
#define SCFSR	*((volatile unsigned short int *)(UartBaseAddr+0x010))
#define SCFRDR	*((volatile unsigned char      *)(UartBaseAddr+0x014))
#define SCFCR	*((volatile unsigned short int *)(UartBaseAddr+0x018))
#define SCFDR	*((volatile unsigned short int *)(UartBaseAddr+0x01C))
#define SCSPTR	*((volatile unsigned short int *)(UartBaseAddr+0x020))
#define SCLSR	*((volatile unsigned short int *)(UartBaseAddr+0x024))

/* |[gRg[䃌WX^ */
#define PFCR1	*((volatile unsigned short int *)(0xFFFE38AC))
#define PFCR0	*((volatile unsigned short int *)(0xFFFE38AE))
#define PJCR0	*((volatile unsigned short int *)(0xFFFE390E))

/* W[X^oCRg[䃌WX^ */
#define STBCR4	*((volatile unsigned char *)(0xFFFE040C))


/* LEDpGPIO */
#define PCDR0	*((volatile unsigned short int *)(0xFFFE3856))
#define PCIOR0	*((volatile unsigned short int *)(0xFFFE3852))
#define PCCR2	*((volatile unsigned short int *)(0xFFFE384A))

/* LbV䃌WX^ */
#define CCR1	*((volatile unsigned int *)(0xFFFC1000))
#define CCR2	*((volatile unsigned int *)(0xFFFC1004))

/* 荞݃Rg[֘A */
#define IBCR	*((volatile unsigned short int *)(0xFFFE080C))
#define IBNR	*((volatile unsigned short int *)(0xFFFE080E))
#define IPR17	*((volatile unsigned short int *)(0xFFFE0C16))

extern int UART_Initialized;
extern int _write (int fd, const void *buf, size_t cnt);
extern void UART_Initialize();
int __OutputToStdOut(unsigned char *buf, int len);
int __StdOutIsInitialized();
int __InitializeStdOut();
extern char *curr_heap_end;
extern char  __heap_top;	
extern char  __heap_end;	

int printHex(unsigned int val);

int main(void)
{
  int	i,LED_flag;
  float LED_flag_acc;
  // int buf_length;
#if 1
  CCR1 = (1<<11) | (1<<3);
  CCR1 = 0;
  CCR1 = (1<<8) |  (1 << 0);

  UART_Initialized = 0;
  if(__StdOutIsInitialized() == 0){ // stdout is not initialized.
    if(__InitializeStdOut() == 0){ // Failed to initialize
      __OutputToStdOut("Failed.\r\n", 9);
      while(1){}
    }
  }

  UART_Initialized = 1;

  curr_heap_end = 0;
#endif
  //UART_Initialized = 0;

  printf("========= SH-2A Started!! =========\r\n");

  //  UART_Initialize();
  //for(i=0;i<8000000;i++){}
  //  char *a;
  //  a = malloc(0x100);

  //__StdOutIsInitialized();
  //printf("Hello World!\n");
  //while(1){}

  //__OutputToStdOut("ABC123\r\n", 8);
  //__OutputToStdOut("ABC456\r\n", 8);
  //__OutputToStdOut("ABC789\r\n", 8);
  //__OutputToStdOut("ABC321\r\n", 8);
  //__OutputToStdOut("ABC654\r\n", 8);

  //_write(2,"yama3\r\n", 7);

  //for(i=0;i<10;i++)
  //    printf("i=%x\r\n", i);

  if(1){
    //__InitializeStdOut();
    //__OutputToStdOut("Hello World!\n", 13);
    //printf("Hello World!%p\r\n",&__heap_top);
    //printf("Hello World!%p\r\n",&__heap_end);
    //printf("Hello World!%p\r\n",curr_heap_end);
    //i=0;
    //printf("%x\r\n", i); i++;
    //printf("%x\r\n", i); i++;
    //printf("%p\r\n", i); i++;
    //puts("Hello World!\n");
  }

  /* LEDo͐ݒ*/
  /* |[gC8 o͐ݒ */
  PCDR0  = PCDR0  & 0xFEFF;	/* PC8='L' */
  PCIOR0 = PCIOR0 | 0x100;	/* PC8=o */
  PCCR2  = PCCR2  & 0xFFF0;	/* |[gI */
  
  /* LED_ */
  LED_flag = 0;
  LED_flag_acc = 1024.1024;
  while(1){
    if (LED_flag == 0){
      PCDR0 = PCDR0 | 0x100;	/* PC8='H' */
      LED_flag = 1;
    }
    else{
      PCDR0 = PCDR0 & 0xFEFF;	/* PC8='L' */
      LED_flag = 0;
    }
    printf("LED_flag = %d, LED_flag_acc = %f\r\n", LED_flag, LED_flag_acc);
    //printf("LED_flag = 0x%x\r\n", LED_flag);
    //printf("LED_flag_acc = %d\r\n", (int)LED_flag_acc);
    //printf("LED_flag = %d\r\n", LED_flag);
    printHex((unsigned int)LED_flag_acc);
    LED_flag_acc += 5;
    for(i=0;i<800000;i++){}
  }


  while(1){}
  return 1;
}
