/* p[}l[WgRg[(PMC) */
#define PMC_SCER		((volatile unsigned int *)(0xFFFFFC00+0x00))
#define PMC_SCDR		((volatile unsigned int *)(0xFFFFFC00+0x04))
#define PMC_SCSR		((volatile unsigned int *)(0xFFFFFC00+0x08))

#define PMC_PCER		((volatile unsigned int *)(0xFFFFFC00+0x10))
#define PMC_PCDR		((volatile unsigned int *)(0xFFFFFC00+0x14))
#define PMC_PCSR		((volatile unsigned int *)(0xFFFFFC00+0x18))

#define CKGR_MOR		((volatile unsigned int *)(0xFFFFFC00+0x20))
#define CKGR_MCFR		((volatile unsigned int *)(0xFFFFFC00+0x24))
#define CKGR_PLLAR		((volatile unsigned int *)(0xFFFFFC00+0x28))
#define CKGR_PLLBR		((volatile unsigned int *)(0xFFFFFC00+0x2C))
#define PMC_MCKR		((volatile unsigned int *)(0xFFFFFC00+0x30))

#define PMC_PCK0		((volatile unsigned int *)(0xFFFFFC00+0x40))
#define PMC_PCK1		((volatile unsigned int *)(0xFFFFFC00+0x44))

#define PMC_SR			((volatile unsigned int *)(0xFFFFFC00+0x68))

#define MASTER_CLOCK	(198656000/2)

/* ėpI/Oo̓Rg[(PIOB) */
#define PIOB_PER		((volatile unsigned int *)(0xFFFFF600+0x00))
#define PIOB_PDR		((volatile unsigned int *)(0xFFFFF600+0x04))
#define PIOB_OER		((volatile unsigned int *)(0xFFFFF600+0x10))
#define PIOB_ODR		((volatile unsigned int *)(0xFFFFF600+0x14))
#define PIOB_IFER		((volatile unsigned int *)(0xFFFFF600+0x20))
#define PIOB_IFDR		((volatile unsigned int *)(0xFFFFF600+0x24))
#define PIOB_IFSR		((volatile unsigned int *)(0xFFFFF600+0x28))
#define PIOB_SODR		((volatile unsigned int *)(0xFFFFF600+0x30))
#define PIOB_ODSR		((volatile unsigned int *)(0xFFFFF600+0x38))
#define PIOB_PDSR		((volatile unsigned int *)(0xFFFFF600+0x3C))
#define PIOB_IER		((volatile unsigned int *)(0xFFFFF600+0x40))
#define PIOB_IDR		((volatile unsigned int *)(0xFFFFF600+0x44))
#define PIOB_IMR		((volatile unsigned int *)(0xFFFFF600+0x48))
#define PIOB_ISR		((volatile unsigned int *)(0xFFFFF600+0x4C))
#define PIOB_ASR		((volatile unsigned int *)(0xFFFFF600+0x70))
#define PIOB_BSR		((volatile unsigned int *)(0xFFFFF600+0x74))
#define PIOB_OWER		((volatile unsigned int *)(0xFFFFF600+0xA0))
#define PIOB_OWDR		((volatile unsigned int *)(0xFFFFF600+0xA4))

int main(){
  int i,j;

  /* PIO A~B NbNCl[u */
  *PMC_PCER = 0x0C;
  
  /* fBbvXCb`(PB25~22)/LED(PB21~18) */
  *PIOB_PER = 0x03FC0000;	/* PB25~18Cl[u */
  *PIOB_OWER= 0x003C0000;	/* PB21~18݃Cl[u */
  *PIOB_SODR= 0x003C0000;	/* LED */
  *PIOB_ODR = 0x03C00000;	/* PB25~22͕ */
  *PIOB_OER = 0x003C0000;	/* PB21~18o͕ */

  // LED̓_
  for(i=0;i<20;i++){
    /* fBbvXCb`̏ԂLEDɏo */
    *PIOB_ODSR = 1 << 18;
    for(j=0;j<1000000;j++){}
    *PIOB_ODSR = 0 << 18;
    for(j=0;j<1000000;j++){}
  }
  return 0;

}
