/* SH2A72623gccTvvO*/
/* Copyright (c) Shinichi Yamagiwa */
/* LED_łȂ犄荞ݐUARTGR[obN܂*/

/* NbNݒRg[䃌WX^ */
#define FRQCR	*((volatile unsigned short int *)(0xFFFE0010))

/* UARTRg[ */
#define	USE_BPS		38400	/* ʐMx 19200 or 38400 */
#define	USE_UART_CH		2	/* UART`l2 or 3 */

#if (USE_BPS == 38400)
#define SCBRR_SET 19
#endif
#if (USE_BPS == 19200)
#define SCBRR_SET 38
#endif

#if (USE_UART_CH == 0)
/* FIFOtVARg[SCIF(SCIF0) */
#define UartBaseAddr (0xFFFE8000)
#endif
#if (USE_UART_CH == 2)
/* FIFOtVARg[SCIF(SCIF2) */
#define UartBaseAddr (0xFFFE9000)
#endif
#if (USE_UART_CH == 3)
/* FIFOtVARg[SCIF(SCIF3) */
#define UartBaseAddr (0xFFFE9800)
#endif

/* FIFOtVARg[SCIF(SCIFx) */
#define SCSMR	*((volatile unsigned short int *)(UartBaseAddr+0x000))
#define SCBRR	*((volatile unsigned char      *)(UartBaseAddr+0x004))
#define SCSCR	*((volatile unsigned short int *)(UartBaseAddr+0x008))
#define SCFTDR	*((volatile unsigned char      *)(UartBaseAddr+0x00C))
#define SCFSR	*((volatile unsigned short int *)(UartBaseAddr+0x010))
#define SCFRDR	*((volatile unsigned char      *)(UartBaseAddr+0x014))
#define SCFCR	*((volatile unsigned short int *)(UartBaseAddr+0x018))
#define SCFDR	*((volatile unsigned short int *)(UartBaseAddr+0x01C))
#define SCSPTR	*((volatile unsigned short int *)(UartBaseAddr+0x020))
#define SCLSR	*((volatile unsigned short int *)(UartBaseAddr+0x024))

/* |[gRg[䃌WX^ */
#define PFCR1	*((volatile unsigned short int *)(0xFFFE38AC))
#define PFCR0	*((volatile unsigned short int *)(0xFFFE38AE))
#define PJCR0	*((volatile unsigned short int *)(0xFFFE390E))

/* W[X^oCRg[䃌WX^ */
#define STBCR4	*((volatile unsigned char *)(0xFFFE040C))


/* LEDpGPIO */
#define PCDR0	*((volatile unsigned short int *)(0xFFFE3856))
#define PCIOR0	*((volatile unsigned short int *)(0xFFFE3852))
#define PCCR2	*((volatile unsigned short int *)(0xFFFE384A))

/* LbV䃌WX^ */
#define CCR1	*((volatile unsigned int *)(0xFFFC1000))
#define CCR2	*((volatile unsigned int *)(0xFFFC1004))

/* 荞݃Rg[֘A */
#define IBCR	*((volatile unsigned short int *)(0xFFFE080C))
#define IBNR	*((volatile unsigned short int *)(0xFFFE080E))
#define IPR17	*((volatile unsigned short int *)(0xFFFE0C16))

void interrupt_handler(){
  unsigned char data;

  if(SCFSR & 0x0002){
    data = SCFRDR;		/* Mf[^ǂݏo */
    SCFSR = SCFSR & 0xFFFC;	/* MtONA */

    while((SCFSR & 0x0020) == 0){}
    SCFTDR = data;		/* Mf[^ */
    SCFSR  = SCFSR & 0xFFDF;	/* MtONA */
  }
  
}


int main(void)
{
  int	i,LED_flag;
  unsigned char c;
  unsigned short int sts;
  unsigned int SR_val;

  /* NbNݒ */
  FRQCR  = 0x1104;	/* B=48M I=144M P=24M */

  /* ߃LbVtbV*/
  CCR1 = (1<<11) | (1<<3);
  CCR1 = 0;
  /* ߃LbVAIyhLbVCl[u*/
  CCR1 = (1<<8) |  (1 << 0); 

  /* R\[(UART) */
#if (USE_UART_CH == 0)
  /* |[gݒ(RXD0(PJ1),TXD0(PJ0)) */
  PJCR0 = (PFCR0&0xFF00)|0x0044;
  /* SCIF0X^oC */
  STBCR4 = (STBCR4 & 0x7F);	/* SCIF0 */
#endif
#if (USE_UART_CH == 2)
  /* |[gݒ(RXD2(PF2),TXD2(PF1))(CQBB P2RlN^) */
  PFCR0 = (PFCR0&0xF00F)|0x0440;
  /* SCIF2X^oC */
  STBCR4 = (STBCR4 & 0xDF);	/* SCIF2 */
#endif
#if (USE_UART_CH == 3)
  /* |[gݒ(RXD3(PF3))(CQBB P1RlN^)*/
  PFCR0 = (PFCR0&0x0FFF)|0x4000;
  /* |[gݒ(TXD3(PF4))(CQBB P1RlN^)*/
  PFCR1 = (PFCR1&0xFFF0)|0x0004;
  /* SCIF3X^oC */
  STBCR4 = (STBCR4 & 0xEF);	/* SCIF3 */
#endif
  /* SCIFxݒ */
  SCSCR = 0x0000;	/* TE=0,RE=0,CKE1=0 */
  SCFCR = 0x0006;	/* TFRST=1,RFRST=1 */
  sts    = SCFSR;	/* MXe[^Xǂ */
  SCFSR = 0x0000;	/* MXe[^XNA */
  SCSMR = 0x0000;	/* CHR=0,PE=0,STOP=0,CKS=00(P/1) */
  SCBRR = SCBRR_SET;	/* ݒ */
  SCFCR = 0x0000;	/* TREG:8bytes RTRG:1bytes */
  SCSCR = 0x0070;	/* TIE=0,RIE=1,TE=1,RE=1, REIE=0 */
  
  
  // 荞݃Cl[u
  //IBCR = 0xFFFF;
  IBNR = 0x4000;
  IPR17 = 0xFFFF;

  asm volatile ("stc sr,%0" : "=r" (SR_val));
  SR_val = (SR_val & ~0xF0) | (14<<4);
  asm volatile ("ldc %0,sr" : : "r" (SR_val));

  /* LEDo͐ݒ*/
  /* |[gC8 o͐ݒ */
  PCDR0  = PCDR0  & 0xFEFF;	/* PC8='L' */
  PCIOR0 = PCIOR0 | 0x100;	/* PC8=o */
  PCCR2  = PCCR2  & 0xFFF0;	/* |[gI */
  
  /* LED_ */
  LED_flag = 0;
  while(1){
    if (LED_flag == 0){
      PCDR0 = PCDR0 | 0x100;	/* PC8='H' */
      LED_flag = 1;
    }
    else{
      PCDR0 = PCDR0 & 0xFEFF;	/* PC8='L' */
      LED_flag = 0;
    }
    for(i=0;i<800000;i++){}

  }

  while(1){}
  return 1;
}
